<?php

namespace Teknisa\DF\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DataSource\DataSet;


class Ger10200ParametrosGrupoFiscalController extends \Teknisa\DF\Controllers\TeknisaCrud {
  protected $dataSourceName = '';
  protected $dataSourceNameToSave ='';
  protected $dataSourceManager;
  protected $entityManager;
  protected $environment;
  protected $Ger10200ParametrosGrupoFiscalService;

  public function __construct($crudService, $parameterBag, $environment,$entityManager,$Ger10200ParametrosGrupoFiscalService) {
        parent::__construct($crudService, $parameterBag);
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->Ger10200ParametrosGrupoFiscalService = $Ger10200ParametrosGrupoFiscalService;
        set_time_limit(120);
  }

  public function saveCliente(DTO\Request $request, DTO\Response $response) {
    try {
      $tipoCadastro = $row = $request->getDataSet()->getRows()[0]['TIPOCADASTRO'];
      $this->dataSourceName = 'cliente';
      switch ($tipoCadastro) {
        case '0':
          $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
          $this->Ger10200ParametrosGrupoFiscalService->updateAllClientes($grupoFiscal);
          break;
        case '1':
          $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
          $resul = $request->getDataSet()->getRows()[0];
          $this->inserirListaCliente($resul,$grupoFiscal,$response,$request);
          break;
        case '2':
          $this->Ger10200ParametrosGrupoFiscalService->updateAllClientes(null);
          break;
        case '3':
          $resul = $request->getDataSet()->getRows()[0];
          $this->inserirListaCliente($resul,'',$response,$request);
          break;
        case '4':
          $rows = $request->getDataSet()->getRows()[0];
          $conditions = $this->retornaCondicaoGrupoFiscal($rows);
          $resul = $this->realizaConsulta($response,$conditions);
          $resul =$resul->getDataSets()[0]->getRows();
          $this->inserirCliente($resul,'',$response,$request);
          break;
        default:
          break;
      }
    } catch (\Exception $e) {
      $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
  }

  public function inserirCliente($rows,$grupoFiscal,$response,$request){
        $this->dataSourceName = 'cliente';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows);$i++){
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('CDCLIENTE', $rows[$i]['CDCLIENTE']);
            $row->set('CDGRUPOFISC', $grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());
            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('cliente', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('cliente', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function inserirListaCliente($rows,$grupoFiscal,$response,$request){
        $this->dataSourceName = 'cliente';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows['CDCLIENTE']);$i++){
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('CDCLIENTE', $rows['CDCLIENTE'][$i]);
            $row->set('CDGRUPOFISC', $grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());

            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('cliente', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('cliente', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function saveFornecedor(DTO\Request $request, DTO\Response $response) {
    try {
      $tipoCadastro = $row = $request->getDataSet()->getRows()[0]['TIPOCADASTRO'];
      $this->dataSourceName = 'fornecedor';
      switch ($tipoCadastro) {
        case '0':
          $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
          $this->Ger10200ParametrosGrupoFiscalService->updateAllFornecedores($grupoFiscal);
          break;
        case '1':
          $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
          $resul = $request->getDataSet()->getRows()[0];
          $this->inserirListaFornecedor($resul,$grupoFiscal,$response,$request);
          break;
        case '2':
          $this->Ger10200ParametrosGrupoFiscalService->updateAllFornecedores(null);
          break;
        case '3':
          $resul = $request->getDataSet()->getRows()[0];
          $this->inserirListaFornecedor($resul,'',$response,$request);
          break;
        case '4':
          $rows = $request->getDataSet()->getRows()[0];
          $conditions = $this->retornaCondicaoGrupoFiscal($rows);
          $resul = $this->realizaConsulta($response,$conditions);
          $resul =$resul->getDataSets()[0]->getRows();
          $this->inserirFornecedor($resul,'',$response,$request);
          break;
        default:
          break;
      }

    } catch (\Exception $e) {
      $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
  }

  public function inserirFornecedor($rows,$grupoFiscal,$response,$request){
        $this->dataSourceName = 'fornecedor';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows);$i++){
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('CDFORNECED', $rows[$i]['CDFORNECED']);
            $row->set('CDGRUPOFISC', $grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());
            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('fornecedor', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('fornecedor', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function inserirListaFornecedor($rows,$grupoFiscal,$response,$request){
        $this->dataSourceName = 'fornecedor';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows['CDFORNECED']);$i++){
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('CDFORNECED', $rows['CDFORNECED'][$i]);
            $row->set('CDGRUPOFISC', $grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());

            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('fornecedor', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('fornecedor', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function saveFilial(DTO\Request $request, DTO\Response $response) {
    try {
      $tipoCadastro = $row = $request->getDataSet()->getRows()[0]['TIPOCADASTRO'];
      $this->dataSourceName = 'filial';
      switch ($tipoCadastro) {
        case '0':
          $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
          $this->Ger10200ParametrosGrupoFiscalService->updateAllFilial($grupoFiscal);
          break;
        case '1':
          $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
          $resul = $request->getDataSet()->getRows()[0];
          $this->inserirListaFilial($resul,$grupoFiscal,$response,$request);
          break;
        case '2':
          $this->Ger10200ParametrosGrupoFiscalService->updateAllFilial(null);
          break;
        case '3':
          $resul = $request->getDataSet()->getRows()[0];
          $this->inserirListaFilial($resul,'',$response,$request);
          break;
        case '4':
          $rows = $request->getDataSet()->getRows()[0];
          $conditions = $this->retornaCondicaoGrupoFiscal($rows);
          $resul = $this->realizaConsulta($response,$conditions);
          $resul =$resul->getDataSets()[0]->getRows();
          $this->inserirFilial($resul,'',$response,$request);
          break;
        default:
          break;
      }
    } catch (\Exception $e) {
      $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
  }

  public function inserirFilial($rows,$grupoFiscal,$response,$request){
        $this->dataSourceName = 'filial';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows);$i++){
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('CDFILIAL', $rows[$i]['CDFILIAL']);
            $row->set('CDGRUPOFISC', $grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());
            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('filial', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('filial', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function inserirListaFilial($rows,$grupoFiscal,$response,$request){
        $this->dataSourceName = 'filial';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows['CDFILIAL']);$i++){
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('CDFILIAL', $rows['CDFILIAL'][$i]);
            $row->set('CDGRUPOFISC', $grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());

            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('filial', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('filial', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function saveTipoOperacao(DTO\Request $request, DTO\Response $response) {
    try {
      $tipoCadastro = $row = $request->getDataSet()->getRows()[0]['TIPOCADASTRO'];
      $this->dataSourceName = 'tipooperac';
      switch ($tipoCadastro) {
        case '0':
          $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
          $this->Ger10200ParametrosGrupoFiscalService->updateAllTipoOperacao($grupoFiscal);
          break;
        case '1':
          $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
          $resul = $request->getDataSet()->getRows()[0];
          $this->inserirListaTipoOperacao($resul,$grupoFiscal,$response,$request);
          break;
        case '2':
          $this->Ger10200ParametrosGrupoFiscalService->updateAllTipoOperacao(null);
          break;
        case '3':
          $resul = $request->getDataSet()->getRows()[0];
          $this->inserirListaTipoOperacao($resul,'',$response,$request);
          break;
        case '4':
          $rows = $request->getDataSet()->getRows()[0];
          $conditions = $this->retornaCondicaoGrupoFiscal($rows);
          $resul = $this->realizaConsulta($response,$conditions);
          $resul =$resul->getDataSets()[0]->getRows();
          $this->inserirTipoOperacao($resul,'',$response,$request);
          break;
        default:
          break;
      }
    } catch (\Exception $e) {
      $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
  }

  public function inserirTipoOperacao($rows,$grupoFiscal,$response,$request){
        $this->dataSourceName = 'tipooperac';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows);$i++){
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('IDENTRSAIDOP', $rows[$i]['IDENTRSAIDOP']);
            $row->set('CDTIPOOPER', $rows[$i]['CDTIPOOPER']);
            $row->set('CDGRUPOFISC', $grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());
            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('tipooperac', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('tipooperac', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function inserirListaTipoOperacao($rows,$grupoFiscal,$response,$request){
        $this->dataSourceName = 'tipooperac';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows['CDTIPOOPER']);$i++){
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('IDENTRSAIDOP', $rows['IDENTRSAIDOP'][$i]);
            $row->set('CDTIPOOPER', $rows['CDTIPOOPER'][$i]);
            $row->set('CDGRUPOFISC', $grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());

            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('tipooperac', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('tipooperac', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function saveTipoContrato(DTO\Request $request, DTO\Response $response) {
    $this->dataSourceName = 'paramfilial';
    $rows = $request->getDataSet()->getRows()[0];
    if($rows['CDAUTO']=="0"){
      $conditions = $this->retornaCondicaoTipoContrato($rows);
      $resul = $this->realizaConsulta($response,$conditions);
      $resul =$resul->getDataSets()[0]->getRows();
      $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
      $this->inserirTipoFaturamento($resul,$grupoFiscal,$response,$request);
    }
    else{
        $tipoCadastro = $row = $request->getDataSet()->getRows()[0]['TIPOCADASTRO'];
        switch ($tipoCadastro) {
          case '0':
            $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
            $conditions = $this->retornaCondicaoNrorg();
            $resul = $this->realizaConsulta($response,$conditions);
            $resul =$resul->getDataSets()[0]->getRows();
            $this->inserirTipoFaturamento($resul,$grupoFiscal,$response,$request);
          break;
          case '1':
            $conditions = $this->retornaCondicaoNrorg();
            $resul = $this->realizaConsulta($response,$conditions);
            $resul =$resul->getDataSets()[0]->getRows();
            $this->inserirTipoFaturamento($resul,'',$response,$request);
          break;
          case '2':
            $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
            $conditions = $this->retornaCondicaoVazio($rows);

            $resul = $this->realizaConsulta($response,$conditions);
            $resul =$resul->getDataSets()[0]->getRows();
            $this->inserirTipoFaturamento($resul,$grupoFiscal,$response,$request);
          break;
          default:
            break;
        }
    }
  }
  
  public function retornaCondicaoTipoContrato($rows) {
    $conditions = array(
        array(
            "value" => $rows['CDTIPOFATUR'],
            "operator" => "=",
            "columnName" => "CDTIPOFATUR"
        ),
        array(
          "value" => $this->environment->getNrOrgTrab(),
          "operator" => "=",
          "columnName" => "NRORG"
        )
    );
    return $conditions;
  }

  public function retornaCondicaoVazio($rows) {
    $conditions = array(
        array(
            "value" =>'',
            "operator" => "IS_NULL",
            "columnName" => "CDGRUPOFISC"
        ),
        array(
          "value" => $this->environment->getNrOrgTrab(),
          "operator" => "=",
          "columnName" => "NRORG"
        )
    );
    return $conditions;
  }

  public function inserirTipoFaturamento($rows,$grupoFiscal,$response,$request){
        $this->dataSourceName = 'paramfilial';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows);$i++){
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('CDFILIAL', $rows[$i]['CDFILIAL']);
            $row->set('CDTIPOFATUR', $rows[$i]['CDTIPOFATUR']);
            $row->set('CDGRUPOFISC', $grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());
            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('paramfilial', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('paramfilial', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function saveTipoGestaoFiscal(DTO\Request $request, DTO\Response $response) {
    try {
      $tipoCadastro = $row = $request->getDataSet()->getRows()[0]['TIPOCADASTRO'];
      $this->dataSourceName = 'tpfaturfis';
      switch ($tipoCadastro) {
        case '0':
          $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
          $this->Ger10200ParametrosGrupoFiscalService->updateAllTipoGestaoFiscal($grupoFiscal);
          break;
        case '1':
          $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
          $resul = $request->getDataSet()->getRows()[0];
          $this->inserirListaTipoGestaoFiscal($resul,$grupoFiscal,$response,$request);
          break;
        case '2':
          $this->Ger10200ParametrosGrupoFiscalService->updateAllTipoGestaoFiscal(null);
          break;
        case '3':
          $resul = $request->getDataSet()->getRows()[0];
          $this->inserirListaTipoGestaoFiscal($resul,'',$response,$request);
          break;
        case '4':
          $rows = $request->getDataSet()->getRows()[0];
          $conditions = $this->retornaCondicaoGrupoFiscal($rows);
          $resul = $this->realizaConsulta($response,$conditions);
          $resul =$resul->getDataSets()[0]->getRows();
          $this->inserirTipoGestaoFiscal($resul,'',$response,$request);
          break;
        default:
          break;
      }
    } catch (\Exception $e) {
      $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
  }

  public function inserirTipoGestaoFiscal($rows,$grupoFiscal,$response,$request){
        $this->dataSourceName = 'tpfaturfis';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows);$i++){
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('CDTPFATURFIS', $rows[$i]['CDTPFATURFIS']);
            $row->set('CDGRUPOFISC', $grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());
            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('tpfaturfis', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('tpfaturfis', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function inserirListaTipoGestaoFiscal($rows,$grupoFiscal,$response,$request){
        $this->dataSourceName = 'tpfaturfis';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows['CDTPFATURFIS']);$i++){
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('CDTPFATURFIS', $rows['CDTPFATURFIS'][$i]);
            $row->set('CDGRUPOFISC', $grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());

            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('tpfaturfis', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('tpfaturfis', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function deleteFilialImposto(DTO\Request $request, DTO\Response $response) {
    $this->dataSourceName = 'grupofiscimpfil_filial_imposto';
    parent::delete($request,$response);
  }

  public function deleteImpostoInscricaoEstadualFornecedor(DTO\Request $request, DTO\Response $response) {
    $this->dataSourceName = 'grfisimpieforn_fornecedor_grupofiscal';
    parent::delete($request,$response);
  }

  public function deleteImpostoInscricaoEstadualCliente(DTO\Request $request, DTO\Response $response) {
    $this->dataSourceName = 'grfisimpieclie_cliente_grupofiscal';
    parent::delete($request,$response);
  }

  public function saveImpostoFilial(DTO\Request $request, DTO\Response $response) {
    try {
        $rows = $request->getDataSet()->getRows()[0];
        $this->dataSourceName = 'grupofiscimpfil';
        if($rows['CDAUTO']=="0"){
            if($request->getDataSet()->getRows()[0]['__is_new']){
                $row = $request->getDataSet()->getRows()[0];
                $condicaoAdicional = $this->retornaCondicao($row);
                $resul = $this->realizaConsulta($response,$condicaoAdicional);
                $resul =$resul->getDataSets()[0]->getRows();
                if(empty($resul)){
                    $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
                    $this->$dataSourceName = 'grupofiscimpfil';
                    $rows = $this->crudService->getRowsToSave($request,$this->$dataSourceName);
                    $this->crudService->save('grupofiscimpfil', $rows);
                }else{
                    $response->setError(new Error('Filial já Possui Grupo Fiscal para este Imposto.', 500));
                }
            }
            else{
                //Antes de atualizar devemos deletar pois a chave CDGRUPOFISC está como chave primária.
                $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
                $this->$dataSourceName = 'grupofiscimpfil';
                $row = $request->getDataSet()->getRows()[0];
                $condicaoAdicional = $this->retornaCondicao($row);
                $resul = $this->realizaConsulta($response,$condicaoAdicional);
                $resul =$resul->getDataSets()[0]->getRows();
                $this->deleteGrupoFiscalFilialImpostoCadastramento($resul[0],$response,$request);
                if($request->getDataSet()->getRows()[0]['CDGRUPOFISC']){
                    $request->getDataSet()->getRows()[0]->set('__is_new', true);
                    $rows = $this->crudService->getRowsToSave($request,$dataSourceName);
                    $this->crudService->save('grupofiscimpfil', $rows);
                }
            }
        }
        else{
            $this->dataSourceName = "grupofiscimpfil";
            $tipoCadastro = $row = $request->getDataSet()->getRows()[0]['TIPOCADASTRO'];
            $imposto = $row = $request->getDataSet()->getRows()[0]['CDIMPOSTO'];
            switch ($tipoCadastro) {
                case '0':
                    $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
                    $rows = $request->getDataSet()->getRows()[0];
                    $conditions = $this->retornaCondicaoImposto($rows);
                    $resul = $this->realizaConsulta($response,$conditions);
                    $resul =$resul->getDataSets()[0]->getRows();
                    if(!empty($resul)){
                        for($i=0;$i<count($resul);$i++){
                            $this->deleteGrupoFiscalFilialImpostoCadastramento($resul[$i],$response,$request);
                        }
                    }
                    $conditions = $this->retornaCondicaoNrorg();
                    $this->dataSourceName = "filial";
                    $resul = $this->realizaConsulta($response,$conditions);
                    $resul = $resul->getDataSets()[1]->getRows();
                    $this->dataSourceName = "grupofiscimpfil";
                    $this->inserirFilialImposto($resul,$grupoFiscal,$imposto,$response,$request);
                    break;
                case '1':
                    $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
                    $resul = $request->getDataSet()->getRows()[0];
                    $conditions = $this->retornaCondicaoExclusaLista($resul,$resul['CDFILIAL']);
                    $resulConsulta = $this->realizaConsulta($response,$conditions);
                    $resulConsulta =$resulConsulta->getDataSets()[0]->getRows();
                    for($i=0;$i <count($resul['CDFILIAL']);$i++){
                        for($j=0;$j<count($resulConsulta);$j++ ){
                            if($resul['CDFILIAL'][$i]==$resulConsulta[$j]['CDFILIAL']){
                                $this->deleteGrupoFiscalFilialImpostoCadastramento($resulConsulta[$j],$response,$request);
                            }
                        }
                    }
                    $this->inserirListaImpostoFilial($resul,$grupoFiscal,$imposto,$response,$request);
                    break;
                case '2':
                    $rows = $request->getDataSet()->getRows()[0];
                    $conditions = $this->retornaCondicaoNrorgImposto($rows);
                    $resul = $this->realizaConsulta($response,$conditions);
                    $resul =$resul->getDataSets()[0]->getRows();
                    for($i=0;$i<count($resul);$i++){
                        $this->deleteGrupoFiscalFilialImpostoCadastramento($resul[$i],$response,$request);
                    }
                    break;
                case '3':
                    $resul = $request->getDataSet()->getRows()[0];
                    $conditions = $this->retornaCondicaoExclusaLista($resul,$resul['CDFILIAL']);
                    $resulConsulta = $this->realizaConsulta($response,$conditions);
                    $resulConsulta =$resulConsulta->getDataSets()[0]->getRows();
                    for($i=0;$i<count($resulConsulta);$i++ ){
                        $this->deleteGrupoFiscalFilialImpostoCadastramento($resulConsulta[$i],$response,$request);
                    }
                    break;
                case '4':
                    $grupoFiscal = $row = $request->getDataSet()->getRows()[0]['CDGRUPOFISC'];
                    $rows = $request->getDataSet()->getRows()[0];
                    $conditions = $this->retornaCondicaoExclusaoGrupoFiscal($imposto,$grupoFiscal);
                    $resul = $this->realizaConsulta($response,$conditions);
                    $resul =$resul->getDataSets()[0]->getRows();
                    for($i=0;$i<count($resul);$i++){
                        $this->deleteGrupoFiscalFilialImpostoCadastramento($resul[$i],$response,$request);
                    }
                    break;
                default:
                    break;
            }
        }
    } catch (\Exception $e) {
        $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
  }

  public function retornaCondicaoExclusaLista($row,$i) {
      $conditions = array(
          array(
              "value" => $row['CDIMPOSTO'],
              "operator" => "=",
              "columnName" => "CDIMPOSTO"
          ),
          array(
              "value" => $i,
              "operator" => "IN",
              "columnName" => "CDFILIAL"
          )
      );
      return $conditions;
  }
  
  public function retornaCondicaoExclusaoGrupoFiscal($imposto,$grupoFiscal) {
      $conditions = array(
          array(
              "value" => $imposto,
              "operator" => "=",
              "columnName" => "CDIMPOSTO"
          ),
          array(
              "value" => $grupoFiscal,
              "operator" => "=",
              "columnName" => "CDGRUPOFISC"
          )
      );
      return $conditions;
  }

  public function retornaCondicao($row) {
      $conditions = array(
          array(
              "value" => $row['CDIMPOSTO'],
              "operator" => "=",
              "columnName" => "CDIMPOSTO"
          ),
          array(
              "value" => $row['CDFILIAL'],
              "operator" => "=",
              "columnName" => "CDFILIAL"
          )
      );
      return $conditions;
  }

  public function retornaCondicaoImposto($row) {
      $conditions = array(
          array(
              "value" => $row['CDIMPOSTO'],
              "operator" => "=",
              "columnName" => "CDIMPOSTO"
          )
      );
      return $conditions;
  }

  public function retornaCondicaoNrorgImposto($row) {
      $conditions = array(
          array(
              "value" => $this->environment->getNrOrgTrab(),
              "operator" => "=",
              "columnName" => "NRORG"
          ),
          array(
              "value" => $row['CDIMPOSTO'],
              "operator" => "=",
              "columnName" => "CDIMPOSTO"
          )
      );
      return $conditions;
  }

  public function deleteGrupoFiscalFilialImpostoCadastramento($rows,$response,$request){
      $this->dataSourceName = "grupofiscimpfil";
      $row = new Row();
      $row->set('__is_new',  false);
      $row->set('__createdLocal',true);
      $row->set('changed',true);
      $row->set('CDFILIAL', $rows['CDFILIAL']);
      $row->set('CDIMPOSTO', $rows['CDIMPOSTO']);
      $row->set('CDGRUPOFISC',$rows['CDGRUPOFISC']);
      $row->set('NRORG',$rows['NRORG']);
      $array[] = $row;
      $dataSet = new DataSet('grupofiscimpfil', $array);
      $request2 = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
      $request = $this->crudService->buildDataSetIfRow($request2, $this->dataSourceName);
      $dataSet = $request->getDataSet();
      $this->Ger10200ParametrosGrupoFiscalService->deletar($dataSet);
      //$this->crudService->delete($response, $dataSet);
  }

  public function inserirFilialImposto($rows,$grupoFiscal,$imposto,$response,$request){
      $this->dataSourceName = 'grupofiscimpfil';
      $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
      $array = array();
      for($i = 0; $i<count($rows);$i++){
          $row = new Row();
          $row->set('__is_new',  true);
          $row->set('__createdLocal',true);
          $row->set('changed',true);
          $row->set('CDFILIAL', $rows[$i]['CDFILIAL']);
          $row->set('CDGRUPOFISC', $rows[$i]['CDGRUPOFISC']);
          $row->set('CDIMPOSTO', $imposto);
          $row->set('CDGRUPOFISC',$grupoFiscal);
          $row->set('NRORG', $this->environment->getNrOrgTrab());
          $array[] = $row;
      }
      try {
          $dataSet = new DataSet('grupofiscimpfil', $array);
          $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
          $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
          $this->crudService->save('grupofiscimpfil', $saveRows);
      }catch (\Exception $e) {
          $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
      }
  }

  public function inserirListaImpostoFilial($rows,$grupoFiscal,$imposto,$response,$request){
        $this->dataSourceName = 'grupofiscimpfil';
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $array = array();
        for($i = 0; $i<count($rows['CDFILIAL']);$i++){
            $row = new Row();
            $row->set('__is_new',  true);
            $row->set('CDFILIAL', $rows['CDFILIAL'][$i]);
            $row->set('CDIMPOSTO', $imposto);
            $row->set('CDGRUPOFISC',$grupoFiscal);
            $row->set('NRORG', $this->environment->getNrOrgTrab());

            $array[] = $row;
        }
        try {
            $dataSet = new DataSet('grupofiscimpfil', $array);
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
            $this->crudService->save('grupofiscimpfil', $saveRows);
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
  }

  public function saveImpostoInscricaoEstadualCliente(DTO\Request $request, DTO\Response $response) {
    try {
      $rows = $request->getDataSet()->getRows()[0];
      $this->dataSourceName = 'grupofiscimpfil';
      if($rows['CDAUTO']=="0"){
          if($request->getDataSet()->getRows()[0]['__is_new']){
            $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
            $this->$dataSourceName = 'grfisimpieclie';
            $rows = $this->crudService->getRowsToSave($request,$this->$dataSourceName);
            $this->crudService->save('grfisimpieclie', $rows);
          }
          else{
            if(!$request->getDataSet()->getRows()[0]['CDGRUPOFISC']){
              $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
              $this->$dataSourceName = 'grfisimpieclie';
              $row = $request->getDataSet()->getRows()[0];
              $this->deleteImpostoIscricaoEstadualCliente($row,$response,$request);
            }else{
                $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
                $this->$dataSourceName = 'grfisimpieclie';
                $rows = $this->crudService->getRowsToSave($request,$this->$dataSourceName);
                $this->crudService->save('grfisimpieclie', $rows);
            }
          }
      }

    } catch (\Exception $e) {
        $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
  }

  public function deleteImpostoIscricaoEstadualCliente($rows,$response,$request){
        $this->dataSourceName = "grfisimpieclie";
        $row = new Row();
        $row->set('__is_new',  false);
        $row->set('__createdLocal',true);
        $row->set('changed',true);
        $row->set('CDCLIENTE', $rows['CDCLIENTE']);
        $row->set('CDINSCESTA', $rows['CDINSCESTA']);
        $row->set('CDIMPOSTO', $rows['CDIMPOSTO']);
        $row->set('CDEMPRESA',$rows['CDEMPRESA']);
        $row->set('NRORG',$rows['NRORG']);
        $array[] = $row;
        $dataSet = new DataSet('grfisimpieclie', $array);
        $request2 = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        $request = $this->crudService->buildDataSetIfRow($request2, $this->dataSourceName);
        $dataSet = $request->getDataSet();
        $this->Ger10200ParametrosGrupoFiscalService->deletar($dataSet);
        //$this->crudService->delete($response, $dataSet);
  }

  public function saveImpostoInscricaoEstadualFornecedor(DTO\Request $request, DTO\Response $response) {
    try {
        $rows = $request->getDataSet()->getRows()[0];
        $this->dataSourceName = 'grupofiscimpfil';
        if($rows['CDAUTO']=="0"){
            if($request->getDataSet()->getRows()[0]['__is_new']){
                    $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
                    $this->$dataSourceName = 'grfisimpieforn';
                    $rows = $this->crudService->getRowsToSave($request,$this->$dataSourceName);
                    $this->crudService->save('grfisimpieforn', $rows);
            }
            else{
                if(!$request->getDataSet()->getRows()[0]['CDGRUPOFISC']){
                  $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
                  $this->$dataSourceName = 'grfisimpieforn';
                  $row = $request->getDataSet()->getRows()[0];
                  $this->deleteImpostoIscricaoEstadualFornecedor($row,$response,$request);
                }else{
                    $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
                    $this->$dataSourceName = 'grfisimpieforn';
                    $rows = $this->crudService->getRowsToSave($request,$this->$dataSourceName);
                    $this->crudService->save('grfisimpieforn', $rows);
                }
            }
        }
        else{}

    } catch (\Exception $e) {
        $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
  }

  public function deleteImpostoIscricaoEstadualFornecedor($rows,$response,$request){
        $this->dataSourceName = "grfisimpieforn";
        $row = new Row();
        $row->set('__is_new',  false);
        $row->set('__createdLocal',true);
        $row->set('changed',true);
        $row->set('CDFORNECED', $rows['CDFORNECED']);
        $row->set('CDINSCESTA', $rows['CDINSCESTA']);
        $row->set('CDIMPOSTO', $rows['CDIMPOSTO']);
        $row->set('CDEMPRESA',$rows['CDEMPRESA']);
        $row->set('NRORG',$rows['NRORG']);
        $array[] = $row;
        $dataSet = new DataSet('grfisimpieforn', $array);
        $request2 = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        $request = $this->crudService->buildDataSetIfRow($request2, $this->dataSourceName);
        $dataSet = $request->getDataSet();
        $this->Ger10200ParametrosGrupoFiscalService->deletar($dataSet);
        //$this->crudService->delete($response, $dataSet);
  }

  public function cadastramentoAutomaticoImpostoInscricaoEstadual(DTO\Request $request, DTO\Response $response){
    try {
      set_time_limit(0); //Remove o limite de tempo de execução do script. Necessário para inserir muitos registros
      $row = $request->getRow();
      $tipoCadastro =  $row['TIPOCADASTRO'];
      $inscricaoEstadual = $this->verificaInscricaoEstadual($row,$request,$response);
      $cliente = $this->verificaCliente($row,$request,$response);
      $fornecedor = $this->verificaFornecedor($row,$request,$response);
      
      switch ($tipoCadastro) {
        case '0':
          if($row['TIPOFORNECEDOR']!=='2'){
            $this->inserirFornecedorImpostoInscricao($inscricaoEstadual ,$fornecedor, $request ,$response,$row);
          }
          if($row['TIPOCLIENTE']!=='2'){
            $this->inserirClienteImpostoInscricao($inscricaoEstadual ,$cliente, $request ,$response,$row);
          }
          break;
        case '1':
          if($row['TIPOFORNECEDOR']!=='2'){
            $this->deleteFornecedorImpostoInscricao($inscricaoEstadual ,$fornecedor, $request ,$response,$row);
          }
          if($row['TIPOCLIENTE']!=='2'){
            $this->deleteClienteImpostoInscricao($inscricaoEstadual ,$cliente, $request ,$response,$row);
          }
          break;
        case '2':
          if($row['TIPOFORNECEDOR']!=='2'){
            $this->deleteFornecedorImpostoInscricaoGrupoFiscal($inscricaoEstadual ,$fornecedor, $request ,$response,$row);
          }
          if($row['TIPOCLIENTE']!=='2'){
            $this->deleteClienteImpostoInscricaoGrupoFiscal($inscricaoEstadual ,$fornecedor, $request ,$response,$row);

          }
          break;
        default:
          break;
      }

    } catch (\Exception $e) {
        $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
  }

  public function verificaInscricaoEstadual($row,$request,$response){
    $this->dataSourceName = 'inscrestad_cadAutomatico';
    if($row['TIPOINSCRICAO']=='0'){
      $conditions = $this->retornaCondicaoNrorg();
      $resul = $this->realizaConsultaBanco($conditions);
      return $resul->getRows();
    }else{
      $array= [];
      for($i=0;$i<count($row['inscricaoEstadual']);$i++){
        $conditions = $this->retornaCondicaoNrorgInscricaoEstadual($row['inscricaoEstadual'][$i]);
        $resul = $this->realizaConsultaBanco($conditions);
        $array[]= $resul->getRows()[0];
      }
      return $array;
    }
  }

  public function verificaCliente($row,$request,$response){
    $this->dataSourceName = 'cliente_cadAutomatico';
    switch ($row['TIPOCLIENTE']) {
      case '0':
        $conditions = $this->retornaCondicaoNrorg();
        $resul = $this->realizaConsultaBanco($conditions);
        return $resul->getRows();
        break;
      case '1':
        $array= [];
        for($i=0;$i<count($row['CDCLIENTE']);$i++){
          $conditions = $this->retornaCondicaoNrorgCliente($row['CDCLIENTE'][$i]);
          $resul = $this->realizaConsultaBanco($conditions);
          $array[]= $resul->getRows()[0];
        }
        return $array;
        break;
      case '2':
        return null;
        break;
      default:
        break;
    }
  }

  public function verificaFornecedor($row,$request,$response){
    $this->dataSourceName = 'fornecedor_cadAutomatico';

    switch ($row['TIPOFORNECEDOR']) {
      case '0':
        $conditions = $this->retornaCondicaoNrorg();
        $resul = $this->realizaConsultaBanco($conditions);
        return $resul->getRows();
        break;
      case '1':
        $array= [];
        for($i=0;$i<count($row['CDFORNECED']);$i++){
          $conditions = $this->retornaCondicaoNrorgFornecedor($row['CDFORNECED'][$i]);
          $resul = $this->realizaConsultaBanco($conditions);
          $array[]= $resul->getRows()[0];
        }
      return $array;
        break;
      case '2':
        return null;
        break;
      default:
        break;
    }
  }

  public function retornaCondicaoNrorgInscricaoEstadual($row) {
    $conditions = array(
      array(
        "value" => $this->environment->getNrOrgTrab(),
        "operator" => "=",
        "columnName" => "NRORG"
      ),
      array(
        "value" => $row['CDINSCESTA'],
        "operator" => "=",
        "columnName" => "CDINSCESTA"
      ),
      array(
        "value" => $row['CDEMPRESA'],
        "operator" => "=",
        "columnName" => "CDEMPRESA"
      )
    );
    return $conditions;
  }

  public function retornaCondicaoNrorgCliente($row) {
    $conditions = array(
      array(
        "value" => $this->environment->getNrOrgTrab(),
        "operator" => "=",
        "columnName" => "NRORG"
      ),
      array(
        "value" => $row,
        "operator" => "=",
        "columnName" => "CDCLIENTE"
      )
    );
    return $conditions;
  }

  public function retornaCondicaoNrorgFornecedor($row) {
    $conditions = array(
      array(
        "value" => $this->environment->getNrOrgTrab(),
        "operator" => "=",
        "columnName" => "NRORG"
      ),
      array(
        "value" => $row,
        "operator" => "=",
        "columnName" => "CDFORNECED"
      )
    );
    return $conditions;
  }

  public function retornaCondicaoFornecedorCompleta($row) {
    $conditions = array(
      array(
        "value" => $this->environment->getNrOrgTrab(),
        "operator" => "=",
        "columnName" => "NRORG"
      ),
      array(
        "value" => $row['CDFORNECED'],
        "operator" => "=",
        "columnName" => "CDFORNECED"
      ),
      array(
        "value" => $row['CDINSCESTA'],
        "operator" => "=",
        "columnName" => "CDINSCESTA"
      ),
      array(
        "value" => $row['CDIMPOSTO'],
        "operator" => "=",
        "columnName" => "CDIMPOSTO"
      ),
      array(
        "value" => $row['CDEMPRESA'],
        "operator" => "=",
        "columnName" => "CDEMPRESA"
      )
    );
    return $conditions;
  }

  public function retornaCondicaoClienteCompleta($row) {
    $conditions = array(
      array(
        "value" => $this->environment->getNrOrgTrab(),
        "operator" => "=",
        "columnName" => "NRORG"
      ),
      array(
        "value" => $row['CDCLIENTE'],
        "operator" => "=",
        "columnName" => "CDCLIENTE"
      ),
      array(
        "value" => $row['CDINSCESTA'],
        "operator" => "=",
        "columnName" => "CDINSCESTA"
      ),
      array(
        "value" => $row['CDIMPOSTO'],
        "operator" => "=",
        "columnName" => "CDIMPOSTO"
      ),
      array(
        "value" => $row['CDEMPRESA'],
        "operator" => "=",
        "columnName" => "CDEMPRESA"
      )
    );
    return $conditions;
  }

  public function inserirFornecedorImpostoInscricao($inscricaoEstadual ,$fornecedor, $request ,$response,$rows){
    $this->dataSourceName = 'grfisimpieforn';
    $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
      
    for($i = 0; $i<count($inscricaoEstadual);$i++){
      for($k=0;$k<count($fornecedor);$k+=250){
        $array = array();
        for($j=$k;$j<$k+250 and$j<count($fornecedor);$j++){
          $row = new Row();
          $row->set('CDEMPRESA',$inscricaoEstadual[$i]['CDEMPRESA']);
          $row->set('CDINSCESTA', $inscricaoEstadual[$i]['CDINSCESTA']);
          $row->set('CDFORNECED', $fornecedor[$j]['CDFORNECED']);
          $row->set('CDIMPOSTO', $rows['CDIMPOSTO']);
          $row->set('CDGRUPOFISC', $rows['CDGRUPOFISC']);
          $row->set('NRORG', $this->environment->getNrOrgTrab());
          $conditions = $this->retornaCondicaoFornecedorCompleta($row);
          $resul = $this->realizaConsultaBanco($conditions);
          if(empty($resul->getRows())){
            $row->set('__is_new', true);
          }
          else{
            $row->set('__is_new', false);
          }
          $array[] = $row;
        }
        try {
          $dataSet = new DataSet('grfisimpieforn', $array);
          $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
          $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
          $this->crudService->save('grfisimpieforn', $saveRows);
        }catch (\Exception $e) {
          $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
      }
    }
  }

  public function inserirClienteImpostoInscricao($inscricaoEstadual ,$cliente, $request ,$response,$rows){
    $this->dataSourceName = 'grfisimpieclie';
    $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
    $maximo=count($cliente)%250;
    if($maximo!=0)
      $limite = (count($cliente)/($maximo));
    else
      $limite = (count($cliente)/($maximo-1));
    for($i = 0; $i<count($inscricaoEstadual);$i++){
        for($k=0;$k<$limite;$k++){
	    $array = array();
	    for($j=($k*$maximo);$j<($maximo*($k+1));$j++){
          $row = new Row();
          $row->set('CDEMPRESA',$inscricaoEstadual[$i]['CDEMPRESA']);
          $row->set('CDINSCESTA', $inscricaoEstadual[$i]['CDINSCESTA']);
          $row->set('CDCLIENTE', $cliente[$j]['CDCLIENTE']);
          $row->set('CDIMPOSTO', $rows['CDIMPOSTO']);
          $row->set('CDGRUPOFISC', $rows['CDGRUPOFISC']);
          $row->set('NRORG', $this->environment->getNrOrgTrab());
          $conditions = $this->retornaCondicaoClienteCompleta($row);
          $resul = $this->realizaConsultaBanco($conditions);
          if(empty($resul->getRows())){
            $row->set('__is_new', true);
          }
          else{
            $row->set('__is_new', false);
          }
          $array[] = $row;
        }
        try {
          $dataSet = new DataSet('grfisimpieclie', $array);
          $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
          $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
          $this->crudService->save('grfisimpieclie', $saveRows);
      }catch (\Exception $e) {
          $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
      }
      }
    }
  }

  public function deleteFornecedorImpostoInscricao($inscricaoEstadual ,$fornecedor, $request ,$response,$rows){
    $this->dataSourceName = 'grfisimpieforn';
    $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
    $maximo=count($fornecedor)%250;
    if($maximo!=0)
      $limite = (count($fornecedor)/($maximo));
    else
      $limite = (count($fornecedor)/($maximo-1));
    for($i = 0; $i<count($inscricaoEstadual);$i++){
       for($k=0;$k<count($fornecedor);$k+=250){
         $array = array();
         for($j=$k;$j<$k+250 and$j<count($fornecedor);$j++){
           $row = new Row();
             $row->set('CDEMPRESA',$inscricaoEstadual[$i]['CDEMPRESA']);
             $row->set('CDINSCESTA', $inscricaoEstadual[$i]['CDINSCESTA']);
             $row->set('CDFORNECED', $fornecedor[$j]['CDFORNECED']);
             $row->set('CDIMPOSTO', $rows['CDIMPOSTO']);
             $row->set('NRORG', $this->environment->getNrOrgTrab());
             $row->set('__is_new', false);
             $array[] = $row;
         }
         try {
             $dataSet = new DataSet('grfisimpieforn', $array);
             $request2 = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
             $request = $this->crudService->buildDataSetIfRow($request2, $this->dataSourceName);
             $dataSet = $request->getDataSet();
             $this->Ger10200ParametrosGrupoFiscalService->deletar($dataSet);
         }catch (\Exception $e) {
           $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
         }
      }
    }
  }

  public function deleteClienteImpostoInscricao($inscricaoEstadual ,$cliente, $request ,$response,$rows){
    $this->dataSourceName = 'grfisimpieclie';
    $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
    $maximo=count($cliente)%250;
    if($maximo!=0)
      $limite = (count($cliente)/($maximo));
    else
      $limite = (count($cliente)/($maximo-1));
    for($i = 0; $i<count($inscricaoEstadual);$i++){
        for($k=0;$k<$limite;$k++){
        $array = array();
        for($j=($k*$maximo);$j<($maximo*($k+1));$j++){
        $row = new Row();
          $row->set('CDEMPRESA',$inscricaoEstadual[$i]['CDEMPRESA']);
          $row->set('CDINSCESTA', $inscricaoEstadual[$i]['CDINSCESTA']);
          $row->set('CDCLIENTE', $cliente[$j]['CDCLIENTE']);
          $row->set('CDIMPOSTO', $rows['CDIMPOSTO']);
          $row->set('NRORG', $this->environment->getNrOrgTrab());
          $row->set('__is_new', false);
          $array[] = $row;
        }
        try {
        $dataSet = new DataSet('grfisimpieclie', $array);
        $request2 = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        $request = $this->crudService->buildDataSetIfRow($request2, $this->dataSourceName);
        $dataSet = $request->getDataSet();
        $this->Ger10200ParametrosGrupoFiscalService->deletar($dataSet);
    }catch (\Exception $e) {
        $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
    }
    }
  }

  public function deleteFornecedorImpostoInscricaoGrupoFiscal($inscricaoEstadual ,$fornecedor, $request ,$response,$rows){
    $this->dataSourceName = 'grfisimpieforn';
    $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
    $maximo=count($fornecedor)%250;
    if($maximo!=0)
      $limite = (count($fornecedor)/($maximo));
    else
      $limite = (count($fornecedor)/($maximo-1));
    for($i = 0; $i<count($inscricaoEstadual);$i++){
      for($k=0;$k<$limite;$k++){
        $array = array();
        $resul =null;
        $conditions = $this->retornaCondicaoInscricaoEstadualGrupoFiscal($rows,$inscricaoEstadual[$i]);
        $resul = $this->realizaConsultaBanco($conditions);
        $resul = $resul->getRows();
        for($j=($k*$maximo);$j<($maximo*($k+1));$j++){
          $row = new Row();
          $row->set('CDEMPRESA',$resul[$j]['CDEMPRESA']);
          $row->set('CDINSCESTA', $resul[$j]['CDINSCESTA']);
          $row->set('CDFORNECED', $resul[$j]['CDFORNECED']);
          $row->set('CDIMPOSTO', $resul[$j]['CDIMPOSTO']);
          $row->set('NRORG', $this->environment->getNrOrgTrab());
          $row->set('__is_new', false);
          $array[] = $row;
        }
        $dataSet = new DataSet('grfisimpieforn', $array);
        $request2 = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        $request = $this->crudService->buildDataSetIfRow($request2, $this->dataSourceName);
        $dataSet = $request->getDataSet();
        $this->Ger10200ParametrosGrupoFiscalService->deletar($dataSet);
}
    }
  }

  public function deleteClienteImpostoInscricaoGrupoFiscal($inscricaoEstadual ,$fornecedor, $request ,$response,$rows){
    $this->dataSourceName = 'grfisimpieclie';
    $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
    $maximo=count($fornecedor)%250;
    if($maximo!=0)
      $limite = (count($fornecedor)/($maximo));
    else
      $limite = (count($fornecedor)/($maximo-1));
    for($i = 0; $i<count($inscricaoEstadual);$i++){
      for($k=0;$k<$limite;$k++){
        $array = array();
        $resul =null;
        $conditions = $this->retornaCondicaoInscricaoEstadualGrupoFiscal($rows,$inscricaoEstadual[$i]);
        $resul = $this->realizaConsultaBanco($conditions);
        $resul = $resul->getRows();
        for($j=($k*$limite);$j<($maximo*($k+1));$j++){
          $row = new Row();
          $row->set('CDEMPRESA',$resul[$j]['CDEMPRESA']);
          $row->set('CDINSCESTA', $resul[$j]['CDINSCESTA']);
          $row->set('CDCLIENTE', $resul[$j]['CDCLIENTE']);
          $row->set('CDIMPOSTO', $resul[$j]['CDIMPOSTO']);
          $row->set('NRORG', $this->environment->getNrOrgTrab());
          $row->set('__is_new', false);
          $array[] = $row;
        }
        $dataSet = new DataSet('grfisimpieclie', $array);
        $request2 = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        $request = $this->crudService->buildDataSetIfRow($request2, $this->dataSourceName);
        $dataSet = $request->getDataSet();
        $this->Ger10200ParametrosGrupoFiscalService->deletar($dataSet);
      }
    }
  }

  public function retornaCondicaoInscricaoEstadualGrupoFiscal($rows,$inscricaoEstadual) {
    $conditions = array(
      array(
        "value" => $inscricaoEstadual['CDINSCESTA'],
        "operator" => "=",
        "columnName" => "CDINSCESTA"
      ),
      array(
        "value" => $rows['CDIMPOSTO'],
        "operator" => "=",
        "columnName" => "CDIMPOSTO"
      ),
      array(
        "value" => $inscricaoEstadual['CDEMPRESA'],
        "operator" => "=",
        "columnName" => "CDEMPRESA"
      ),
      array(
        "value" => $rows['CDGRUPOFISC'],
        "operator" => "=",
        "columnName" => "CDGRUPOFISC"
      ),
      array(
        "value" => $this->environment->getNrOrgTrab(),
        "operator" => "=",
        "columnName" => "NRORG"
      )
    );
    return $conditions;
  }

  public function replicaoAliquotas(DTO\Request $request, DTO\Response $response){
    $row = $request->getRow();
    if($row['TIPOTELA']=='FORNECEDOR'){
      $conditions = $this->retornaCondicaoReplicacao($row);
      $this->dataSourceName = 'grfisimpieforn';
      $fornecedores = $this->realizaConsultaBanco($conditions);
      $fornecedores = $fornecedores->getRows();
      $inscricaoEstadual = $this->verificaInscricaoEstadualReplicacao($row,$request,$response);
      $imposto=$row['CDIMPOSTO'];
      $this->inserirFornecedorReplicacao($inscricaoEstadual,$fornecedores,$imposto ,$request ,$response);
    }
    if($row['TIPOTELA']=='CLIENTE'){
      $conditions = $this->retornaCondicaoReplicacao($row);
      $this->dataSourceName = 'grfisimpieclie';
      $clientes = $this->realizaConsultaBanco($conditions);
      $clientes = $clientes->getRows();
      $inscricaoEstadual = $this->verificaInscricaoEstadualReplicacao($row,$request,$response);
      $imposto=$row['CDIMPOSTO'];
      $this->inserirClienteReplicacao($inscricaoEstadual,$clientes,$imposto ,$request ,$response);
    }
  }

  public function inserirFornecedorReplicacao($inscricaoEstadual ,$fornecedor,$imposto, $request ,$response){
    $this->dataSourceName = 'grfisimpieforn';
    $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
    $array = array();
    for($i = 0; $i<count($inscricaoEstadual);$i++){
        for($j=0;$j<count($fornecedor);$j++){
          $row = new Row();
          $row->set('CDEMPRESA',$inscricaoEstadual[$i]['CDEMPRESA']);
          $row->set('CDINSCESTA', $inscricaoEstadual[$i]['CDINSCESTA']);
          $row->set('CDFORNECED', $fornecedor[$j]['CDFORNECED']);
          $row->set('CDIMPOSTO', $imposto);
          $row->set('CDGRUPOFISC', $fornecedor[$j]['CDGRUPOFISC']);
          $row->set('NRORG', $this->environment->getNrOrgTrab());
          $conditions = $this->retornaCondicaoFornecedorCompleta($row);
          $resul = $this->realizaConsultaBanco($conditions);
          if(empty($resul->getRows())){
            $row->set('__is_new', true);
          }
          else{
            $row->set('__is_new', false);
          }
          $array[] = $row;
        }
    }
    try {
        $dataSet = new DataSet('grfisimpieforn', $array);
        $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
        $this->crudService->save('grfisimpieforn', $saveRows);
    }catch (\Exception $e) {
        $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
  }

  public function inserirClienteReplicacao($inscricaoEstadual,$cliente,$imposto, $request ,$response){
    $this->dataSourceName = 'grfisimpieclie';
    $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
    $array = array();
    for($i = 0; $i<count($inscricaoEstadual);$i++){
        for($j=0;$j<count($cliente);$j++){
          $row = new Row();
          $row->set('CDEMPRESA',$inscricaoEstadual[$i]['CDEMPRESA']);
          $row->set('CDINSCESTA', $inscricaoEstadual[$i]['CDINSCESTA']);
          $row->set('CDCLIENTE', $cliente[$j]['CDCLIENTE']);
          $row->set('CDIMPOSTO', $imposto);
          $row->set('CDGRUPOFISC', $cliente[$j]['CDGRUPOFISC']);
          $row->set('NRORG', $this->environment->getNrOrgTrab());
          $conditions = $this->retornaCondicaoClienteCompleta($row);
          $resul = $this->realizaConsultaBanco($conditions);
          if(empty($resul->getRows())){
            $row->set('__is_new', true);
          }
          else{
            $row->set('__is_new', false);
          }
          $array[] = $row;
        }
    }
    try {
        $dataSet = new DataSet('grfisimpieclie', $array);
        $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        $saveRows = $this->crudService->getRowsToSave($requestSalvar,$dataSourceName);
        $this->crudService->save('grfisimpieclie', $saveRows);
    }catch (\Exception $e) {
        $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
    }
  }

  public function verificaInscricaoEstadualReplicacao($row,$request,$response){
    $this->dataSourceName = 'inscrestad';
    if($row['TIPOINSCRICAO']=='0'){
      $conditions = $this->retornaCondicaoNrorgEmpresa($row);
      $resul = $this->realizaConsultaBanco($conditions);
      return $resul->getRows();
    }else{
      $array= [];
      for($i=0;$i<count($row['inscricaoEstadual']);$i++){
        $conditions = $this->retornaCondicaoNrorgInscricaoEstadual($row['inscricaoEstadual'][$i]);
        $resul = $this->realizaConsultaBanco($conditions);
        $array[]= $resul->getRows()[0];
      }
      return $array;
    }
  }

  public function realizaConsulta($response,$conditions) {
    $filterCriteria = new FilterCriteria($this->dataSourceName,$conditions);
    $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
    $this->crudService->find($response,$newFilterCriteria);
    return $response;
  }
  
  public function realizaConsultaBanco($conditions) {
    $filterCriteria = new FilterCriteria($this->dataSourceName,$conditions);
    $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
    $dataSet = $this->Ger10200ParametrosGrupoFiscalService->buscar($newFilterCriteria);
    return $dataSet;
  }

  public function retornaCondicaoNrorgEmpresa($row) {
    $conditions = array(
      array(
        "value" => $this->environment->getNrOrgTrab(),
        "operator" => "=",
        "columnName" => "NRORG"
      ),
      array(
        "value" => $row['CDEMPRESADESTINO'],
        "operator" => "=",
        "columnName" => "CDEMPRESA"
      )
    );
    return $conditions;
  }

  public function retornaCondicaoNrorg() {
    $conditions = array(
      array(
        "value" => $this->environment->getNrOrgTrab(),
        "operator" => "=",
        "columnName" => "NRORG"
      )
    );
    return $conditions;
  }

  public function retornaCondicaoGrupoFiscal($rows) {
    $conditions = array(
        array(
            "value" => $rows['CDGRUPOFISC'],
            "operator" => "=",
            "columnName" => "CDGRUPOFISC"
        ),
        array(
          "value" => $this->environment->getNrOrgTrab(),
          "operator" => "=",
          "columnName" => "NRORG"
        )
    );
    return $conditions;
  }

  public function retornaCondicaoReplicacao($row) {
    if($row['TIPOGRUPO']=='1'){
      $conditions = array();
      $conditions [] =
          array(
              "value" => $row['CDGRUPOFISC'],
              "operator" => "IN",
              "columnName" => "CDGRUPOFISC"
          );

      $conditions [] =
        array(
          "value" => $row['CDEMPRESA'],
          "operator" => "=",
          "columnName" => "CDEMPRESA"
        );
      $conditions [] =
        array(
          "value" => $row['CDINSCESTA'],
          "operator" => "=",
          "columnName" => "CDINSCESTA"
        );
      $conditions [] =
        array(
          "value" => $row['CDIMPOSTO'],
          "operator" => "=",
          "columnName" => "CDIMPOSTO"
        );
      return $conditions;
    }
    else{
      $this->dataSourceName = 'grupofiscal';
      $conditions = $this->retornaCondicaoNrorg($row);
      $resul = $this->realizaConsultaBanco($conditions);
      $resul = $resul ->getRows();
      $array=[];
      for($i=0; $i<count($resul) ;$i++){
        $array[]= $resul[$i]['CDGRUPOFISC'];
      }
      $conditions = array();
      $conditions [] =
          array(
              "value" => $array,
              "operator" => "IN",
              "columnName" => "CDGRUPOFISC"
          );
      $conditions [] =
        array(
          "value" => $row['CDEMPRESA'],
          "operator" => "=",
          "columnName" => "CDEMPRESA"
        );
      $conditions [] =
        array(
          "value" => $row['CDINSCESTA'],
          "operator" => "=",
          "columnName" => "CDINSCESTA"
        );
      $conditions [] =
        array(
          "value" => $row['CDIMPOSTO'],
          "operator" => "=",
          "columnName" => "CDIMPOSTO"
        );
      return $conditions;

    }
  }
}